ZOJ3329之经典概率DP

时间:2014-05-13 06:06:00   收藏:0   阅读:357

One Person Game

Time Limit: 1 Second      Memory Limit: 32768 KB      Special Judge

There is a very simple and interesting one-person game. You have 3 dice, namely Die1Die2 and Die3Die1 has K1 faces. Die2 has K2 faces. Die3 has K3 faces. All the dice are fair dice, so the probability of rolling each value, 1 to K1K2K3 is exactly 1 / K1, 1 / K2 and 1 / K3. You have a counter, and the game is played as follow:

  1. Set the counter to 0 at first.
  2. Roll the 3 dice simultaneously. If the up-facing number of Die1 is a, the up-facing number of Die2 is b and the up-facing number of Die3 is c, set the counter to 0. Otherwise, add the counter by the total value of the 3 up-facing numbers.
  3. If the counter‘s number is still not greater than n, go to step 2. Otherwise the game is ended.

Calculate the expectation of the number of times that you cast dice before the end of the game.

Input

There are multiple test cases. The first line of input is an integer T (0 < T <= 300) indicating the number of test cases. Then T test cases follow. Each test case is a line contains 7 non-negative integers nK1K2K3abc (0 <= n <= 500, 1 < K1K2K3 <= 6, 1 <= a <= K1, 1 <= b <= K2, 1 <= c <= K3).

Output

For each test case, output the answer in a single line. A relative error of 1e-8 will be accepted.

Sample Input

2
0 2 2 2 1 1 1
0 6 6 6 1 1 1

Sample Output

1.142857142857143
1.004651162790698

http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=3754

/*题意:
有三个骰子,分别有k1,k2,k3个面。
每次掷骰子,如果三个面分别为a,b,c则分数置0,否则加上三个骰子的分数之和。
当分数大于n时结束。求游戏的期望步数。初始分数为0

分析:
假设dp[i]表示拥有分数i到游戏结束的期望步数
则 
(1):dp[i]=SUM(p[k]*dp[i+k])+p[0]*dp[0]+1;//p[k]表示增加分数为k的概率,p[0]表示分数变为0的概率
假定
(2):dp[i]=A[i]*dp[0]+B[i];
则
(3):dp[i+k]=A[i+k]*dp[0]+B[i+k];
将(3)代入(1)得:
(4):dp[i]=(SUM(p[k]*A[i+k])+p[0])*dp[0]+SUM(p[k]*B[i+k])+1;
将4与2做比较得:
A[i]=(SUM(p[k]*A[i+k])+p[0]);
B[i]=SUM(p[k]*B[i+k])+1;
当i+k>n时A[i+k]=B[i+k]=0可知
所以dp[0]=B[0]/(1-A[0])可求出
*************************************************************************
总结下这类概率DP:
既DP[i]可能由DP[i+k]和DP[i+j]需要求的比如DP[0]决定
相当于概率一直递推下去会回到原点 
比如
(1):DP[i]=a*DP[i+k]+b*DP[0]+d*DP[i+j]+c; 
但是DP[i+k]和DP[0]都是未知
这时候根据DP[i]的方程式假设一个方程式:
比如:
(2):DP[i]=A[i]*DP[i+k]+B[i]*DP[0]+C[i];
因为要求DP[0],所以当i=0的时候但是A[0],B[0],C[0]未知
对比(1)和(2)的差别 
这时候对比(1)和(2)发现两者之间的差别在于DP[i+j]
所以根据(2)求DP[i+j]然后代入(1)消除然后对比(2)就可以得到A[i],B[i],C[i]
然后视具体情况根据A[i],B[i],C[i]求得A[0],B[0],C[0]继而求DP[0] 
请看这题:http://acm.hdu.edu.cn/showproblem.php?pid=4035 
*************************************************************************
*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <queue>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>
#define INF 99999999
typedef long long LL;
using namespace std;

const int MAX=500+10;
int n,k1,k2,k3,a,b,c;
double p[20],A[MAX+10],B[MAX+10];

void dfs(int i){//求A[i],B[i]
	if(A[i]>0)return;
	if(i>n){A[i]=B[i]=0;return;}
	A[i]=p[0],B[i]=1;
	for(int k=3;k<=k1+k2+k3;++k){
		dfs(i+k);
		A[i]+=p[k]*A[i+k];
		B[i]+=p[k]*B[i+k];
	}
}

int main(){
	int t;
	scanf("%d",&t);
	while(t--){
		memset(p,0,sizeof p);
		scanf("%d%d%d%d%d%d%d",&n,&k1,&k2,&k3,&a,&b,&c);
		p[0]=1.0/(k1*k2*k3);
		for(int i=1;i<=k1;++i){
			for(int j=1;j<=k2;++j){
				for(int k=1;k<=k3;++k){
					p[i+j+k]+=p[0];//求i+j+k的概率 
				}
			}
		}
		p[a+b+c]-=p[0];//a+b+c的分数不能等于a,b,c,所以需要减去 
		memset(A,0,sizeof A);
		memset(B,0,sizeof B);
		dfs(0);
	  /*memset(A,0,sizeof A);
		memset(B,0,sizeof B);
		for(int i=n;i>=0;--i){
			A[i]=p[0],B[i]=1;
			for(int k=3;k<=k1+k2+k3;++k){
				A[i]+=p[k]*A[i+k];
				B[i]+=p[k]*B[i+k];
			}
		}*/
		printf("%.15f\n",B[0]/(1-A[0]));
	}
	return 0;
}


ZOJ3329之经典概率DP,布布扣,bubuko.com

评论(0
© 2014 mamicode.com 版权所有 京ICP备13008772号-2  联系我们:gaon5@hotmail.com
迷上了代码!